diff --git a/drivers/net/iavf/iavf_rxtx_vec_avx2.c b/drivers/net/iavf/iavf_rxtx_vec_avx2.c
index 86290c4bbb..184fa30e0e 100644
--- a/drivers/net/iavf/iavf_rxtx_vec_avx2.c
+++ b/drivers/net/iavf/iavf_rxtx_vec_avx2.c
@@ -1397,36 +1397,42 @@ _iavf_recv_raw_pkts_vec_avx2_flex_rxd(struct iavf_rx_queue *rxq,
 					(_mm256_castsi256_si128(status0_7)));
 		received += burst;
 #ifndef RTE_LIBRTE_IAVF_16BYTE_RX_DESC
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wimplicit-fallthrough"
 		if (rxq->offloads & RTE_ETH_RX_OFFLOAD_TIMESTAMP) {
 			inflection_point = (inflection_point <= burst) ? inflection_point : 0;
 			switch (inflection_point) {
 			case 1:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 0],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 2:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 1],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 3:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 2],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 4:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 3],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 5:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 4],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 6:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 5],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 7:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 6],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 8:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 7],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
 				rxq->phc_time += (uint64_t)1 << 32;
+				/* fallthrough */
 			case 0:
 				break;
 			default:
@@ -1436,7 +1442,6 @@ _iavf_recv_raw_pkts_vec_avx2_flex_rxd(struct iavf_rx_queue *rxq,
 
 			rxq->hw_time_update = rte_get_timer_cycles() / (rte_get_timer_hz() / 1000);
 		}
-#pragma GCC diagnostic pop
 #endif
 		if (burst != IAVF_DESCS_PER_LOOP_AVX)
 			break;
diff --git a/drivers/net/iavf/iavf_rxtx_vec_avx512.c b/drivers/net/iavf/iavf_rxtx_vec_avx512.c
index f9961e53b8..38649b6f0b 100644
--- a/drivers/net/iavf/iavf_rxtx_vec_avx512.c
+++ b/drivers/net/iavf/iavf_rxtx_vec_avx512.c
@@ -1551,36 +1551,42 @@ _iavf_recv_raw_pkts_vec_avx512_flex_rxd(struct iavf_rx_queue *rxq,
 		received += burst;
 #ifndef RTE_LIBRTE_IAVF_16BYTE_RX_DESC
 #ifdef IAVF_RX_TS_OFFLOAD
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wimplicit-fallthrough"
 		if (rxq->offloads & RTE_ETH_RX_OFFLOAD_TIMESTAMP) {
 			inflection_point = (inflection_point <= burst) ? inflection_point : 0;
 			switch (inflection_point) {
 			case 1:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 0],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 2:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 1],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 3:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 2],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 4:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 3],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 5:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 4],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 6:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 5],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 7:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 6],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 8:
 				*RTE_MBUF_DYNFIELD(rx_pkts[i + 7],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
 				rxq->phc_time += (uint64_t)1 << 32;
+				/* fallthrough */
 			case 0:
 				break;
 			default:
@@ -1590,7 +1596,6 @@ _iavf_recv_raw_pkts_vec_avx512_flex_rxd(struct iavf_rx_queue *rxq,
 
 			rxq->hw_time_update = rte_get_timer_cycles() / (rte_get_timer_hz() / 1000);
 		}
-#pragma GCC diagnostic pop
 #endif
 #endif
 		if (burst != IAVF_DESCS_PER_LOOP_AVX)
diff --git a/drivers/net/iavf/iavf_rxtx_vec_sse.c b/drivers/net/iavf/iavf_rxtx_vec_sse.c
index b754122c51..81ea154519 100644
--- a/drivers/net/iavf/iavf_rxtx_vec_sse.c
+++ b/drivers/net/iavf/iavf_rxtx_vec_sse.c
@@ -1126,24 +1126,26 @@ _recv_raw_pkts_vec_flex_rxd(struct iavf_rx_queue *rxq,
 		nb_pkts_recd += var;
 
 #ifndef RTE_LIBRTE_IAVF_16BYTE_RX_DESC
-#pragma GCC diagnostic push
-#pragma GCC diagnostic ignored "-Wimplicit-fallthrough"
 		if (rxq->offloads & RTE_ETH_RX_OFFLOAD_TIMESTAMP) {
 			inflection_point = (inflection_point <= var) ? inflection_point : 0;
 			switch (inflection_point) {
 			case 1:
 				*RTE_MBUF_DYNFIELD(rx_pkts[pos + 0],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 2:
 				*RTE_MBUF_DYNFIELD(rx_pkts[pos + 1],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 3:
 				*RTE_MBUF_DYNFIELD(rx_pkts[pos + 2],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
+				/* fallthrough */
 			case 4:
 				*RTE_MBUF_DYNFIELD(rx_pkts[pos + 3],
 					iavf_timestamp_dynfield_offset + 4, uint32_t *) += 1;
 				rxq->phc_time += (uint64_t)1 << 32;
+				/* fallthrough */
 			case 0:
 				break;
 			default:
@@ -1153,7 +1155,6 @@ _recv_raw_pkts_vec_flex_rxd(struct iavf_rx_queue *rxq,
 
 			rxq->hw_time_update = rte_get_timer_cycles() / (rte_get_timer_hz() / 1000);
 		}
-#pragma GCC diagnostic pop
 #endif
 
 		if (likely(var != IAVF_VPMD_DESCS_PER_LOOP))